Attribute VB_Name = "Module1"
Option Explicit

Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long


Public TargetX!, TargetY!, kStempel As Boolean, sysTarget As Boolean




Public Sub KorrFilter(ByRef Pic As PictureBox, _
                       Optional x1 As Long = -1, Optional y1 As Long = -1, _
                       Optional x2 As Long = -1, Optional y2 As Long = -1, _
                       Optional xtg As Single = 0, Optional ytg As Single = 0, _
                       Optional Grad As Integer = 8)
                                        
  Dim intDrawMode As Integer
  Dim lngReadColor As Long
  Dim lngWriteColor As Long
  Dim Rs As Long
  Dim Gs As Long
  Dim Bs As Long
  Dim X As Single
  Dim Y As Single
  
  On Error GoTo ErrorHandler
  
  If (x1 = -1) And (y1 = -1) And (x2 = -1) And (y2 = -1) Then Exit Sub
  
  With Pic
    intDrawMode = .DrawMode
    .DrawMode = vbCopyPen
        
        Dim xMid As Single, yMid As Single
        If x1 < x2 Then
           xMid = x1 + ((x2 - x1) / 2)
        Else
           xMid = x2 + ((x1 - x2) / 2)
        End If
        If y1 < y2 Then
           yMid = y1 + ((y2 - y1) / 2)
        Else
           yMid = y2 + ((y1 - y2) / 2)
        End If
        
        For X = x1 To x2
          For Y = y1 To y2
            If radiusAF(x1:=xMid, y1:=yMid, x2:=X, y2:=Y) < Grad Then 'Fr Rundung
               lngReadColor = GetPixel(hDC:=.hDC, X:=X + xtg, Y:=Y + ytg)
               GetRGBColor lngColor:=lngReadColor, Rs:=Rs, Gs:=Gs, Bs:=Bs
               lngWriteColor = RGB(Abs(Rs), _
                                   Abs(Gs), _
                                   Abs(Bs))
               SetPixel hDC:=.hDC, X:=X, Y:=Y, crColor:=lngWriteColor
            End If
          Next
          Pic.Refresh
        Next
      
    .DrawMode = intDrawMode
    .Refresh
  End With
  Exit Sub

ErrorHandler:
  Exit Sub
End Sub

Private Function radiusAF(x1!, y1!, x2!, y2!) As Single
  Dim A!, B!
  On Error Resume Next
  'Radiuswert aus zwei Koordinatenpaaren ermitteln
  A! = Abs(x1! - x2!)
  B! = Abs(y1! - y2!)
  radiusAF = Sqr(A! * A! + B! * B!)
End Function

Private Sub GetRGBColor(lngColor As Long, ByRef Rs As Long, _
                        ByRef Gs As Long, ByRef Bs As Long)
  On Error GoTo ErrorHandler
  
  Rs = lngColor Mod 256
  Gs = (lngColor \ 256) Mod 256
  Bs = (lngColor \ 256) \ 256
  Exit Sub
  
ErrorHandler:
  Exit Sub
End Sub


